<?php
namespace Koe\KoeContentmodules\Domain\Model;

/**
 * Content
 */
class Content extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * header
	 *
	 * @var string
	 */
	protected $header = '';

	/**
	 * headerLayout
	 *
	 * @var string
	 */
	protected $headerLayout = '';

	/**
	 * image
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 */
	protected $image = NULL;

	/**
	 * moduleDownloads
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Koe\KoeContentmodules\Domain\Model\ModuleDownload>
	 * @cascade remove
	 */
	protected $moduleDownloads = NULL;

	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->moduleDownloads = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Returns the header
	 *
	 * @return string $header
	 */
	public function getHeader() {
		return $this->header;
	}

	/**
	 * Returns the headerLayout
	 *
	 * @return string $headerLayout
	 */
	public function getHeaderLayout() {
		return $this->headerLayout;
	}

	/**
	 * Returns the image
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 */
	public function getImage() {
		return $this->image;
	}

	/**
	 * Returns the boolean state of noSlide
	 *
	 * @return boolean
	 */
	public function isNoSlide() {
		return $this->noSlide;
	}

	/**
	 * Adds a ModuleDownload
	 *
	 * @param \Koe\KoeContentmodules\Domain\Model\ModuleDownload $moduleDownload
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Koe\KoeContentmodules\Domain\Model\ModuleDownload> moduleDownloads
	 */
	public function addModuleDownload(\Koe\KoeContentmodules\Domain\Model\ModuleDownload $moduleDownload) {
		$this->moduleDownloads->attach($moduleDownload);
	}

	/**
	 * Removes a ModuleDownload
	 *
	 * @param \Koe\KoeContentmodules\Domain\Model\ModuleDownload $moduleDownloadToRemove The ModuleDownload to be removed
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Koe\KoeContentmodules\Domain\Model\ModuleDownload> moduleDownloads
	 */
	public function removeModuleDownload(\Koe\KoeContentmodules\Domain\Model\ModuleDownload $moduleDownloadToRemove) {
		$this->moduleDownloads->detach($moduleDownloadToRemove);
	}

	/**
	 * Returns the moduleDownloads
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Koe\KoeContentmodules\Domain\Model\ModuleDownload> moduleDownloads
	 */
	public function getModuleDownloads() {
		return $this->moduleDownloads;
	}

	/**
	 * Sets the moduleDownloads
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Koe\KoeContentmodules\Domain\Model\ModuleDownload> $moduleDownloads
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Koe\KoeContentmodules\Domain\Model\ModuleDownload> moduleDownloads
	 */
	public function setModuleDownloads(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $moduleDownloads) {
		$this->moduleDownloads = $moduleDownloads;
	}

}